Index: tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/DefaultOfficeManagerConfiguration.java
===================================================================
--- tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/DefaultOfficeManagerConfiguration.java	(revision 2405)
+++ tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/DefaultOfficeManagerConfiguration.java	(revision 2406)
@@ -21,203 +21,220 @@
 import org.artofsolving.jodconverter.util.PlatformUtils;
 
 public class DefaultOfficeManagerConfiguration {
-
-    public static final long DEFAULT_RETRY_TIMEOUT = 120000L;
-    public static boolean DEBUG = false;
-    private File officeHome = OfficeUtils.getDefaultOfficeHome();
-    private OfficeConnectionProtocol connectionProtocol = OfficeConnectionProtocol.SOCKET;
-    private int[] portNumbers = new int[] { 2002 };
-    private String[] pipeNames = new String[] { "office" };
-    private String[] runAsArgs = null;
-    private File templateProfileDir = null;
-    private File workDir = new File(System.getProperty("java.io.tmpdir"));
-    private long taskQueueTimeout = 30000L;  // 30 seconds
-    private long taskExecutionTimeout = 120000L;  // 2 minutes
-    private int maxTasksPerProcess = 200;
-    private long retryTimeout = DEFAULT_RETRY_TIMEOUT;
-
-    private ProcessManager processManager = null;  // lazily initialised
-
-    public DefaultOfficeManagerConfiguration setOfficeHome(String officeHome) throws NullPointerException, IllegalArgumentException {
-        checkArgumentNotNull("officeHome", officeHome);
-        return setOfficeHome(new File(officeHome));
-    }
-
-    public DefaultOfficeManagerConfiguration setOfficeHome(File officeHome) throws NullPointerException, IllegalArgumentException  {
-        checkArgumentNotNull("officeHome", officeHome);
-        checkArgument("officeHome", officeHome.isDirectory(), "must exist and be a directory");
-        this.officeHome = officeHome;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setConnectionProtocol(OfficeConnectionProtocol connectionProtocol) throws NullPointerException {
-        checkArgumentNotNull("connectionProtocol", connectionProtocol);
-        this.connectionProtocol = connectionProtocol;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setPortNumber(int portNumber) {
-        this.portNumbers = new int[] { portNumber };
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setPortNumbers(int... portNumbers) throws NullPointerException, IllegalArgumentException {
-        checkArgumentNotNull("portNumbers", portNumbers);
-        checkArgument("portNumbers", portNumbers.length > 0, "must not be empty");
-        this.portNumbers = portNumbers;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setPipeName(String pipeName) throws NullPointerException {
-        checkArgumentNotNull("pipeName", pipeName);
-        this.pipeNames = new String[] { pipeName };
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setPipeNames(String... pipeNames) throws NullPointerException, IllegalArgumentException {
-        checkArgumentNotNull("pipeNames", pipeNames);
-        checkArgument("pipeNames", pipeNames.length > 0, "must not be empty");
-        this.pipeNames = pipeNames;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setRunAsArgs(String... runAsArgs) {
+	
+	public static final long DEFAULT_RETRY_TIMEOUT = 120000L;
+	
+	public static boolean DEBUG = false;
+	
+	private File officeHome = OfficeUtils.getDefaultOfficeHome();
+	
+	private OfficeConnectionProtocol connectionProtocol = OfficeConnectionProtocol.SOCKET;
+	
+	private int[] portNumbers = new int[] { 2002 };
+	
+	private String[] pipeNames = new String[] { "office" };
+	
+	private String[] runAsArgs = null;
+	
+	private File templateProfileDir = null;
+	
+	private File workDir = new File(System.getProperty("java.io.tmpdir"));
+	
+	private long taskQueueTimeout = 30000L;  // 30 seconds
+	
+	private long taskExecutionTimeout = 120000L;  // 2 minutes
+	
+	private int maxTasksPerProcess = 200;
+	
+	private long retryTimeout = DEFAULT_RETRY_TIMEOUT;
+	
+	private ProcessManager processManager = null;  // lazily initialised
+	
+	public DefaultOfficeManagerConfiguration setOfficeHome(String officeHome) throws NullPointerException, IllegalArgumentException {
+		checkArgumentNotNull("officeHome", officeHome);
+		return setOfficeHome(new File(officeHome));
+	}
+	
+	public DefaultOfficeManagerConfiguration setOfficeHome(File officeHome) throws NullPointerException, IllegalArgumentException {
+		checkArgumentNotNull("officeHome", officeHome);
+		checkArgument("officeHome", officeHome.isDirectory(), "must exist and be a directory");
+		this.officeHome = officeHome;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setConnectionProtocol(OfficeConnectionProtocol connectionProtocol) throws NullPointerException {
+		checkArgumentNotNull("connectionProtocol", connectionProtocol);
+		this.connectionProtocol = connectionProtocol;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setPortNumber(int portNumber) {
+		this.portNumbers = new int[] { portNumber };
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setPortNumbers(int... portNumbers) throws NullPointerException, IllegalArgumentException {
+		checkArgumentNotNull("portNumbers", portNumbers);
+		checkArgument("portNumbers", portNumbers.length > 0, "must not be empty");
+		this.portNumbers = portNumbers;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setPipeName(String pipeName) throws NullPointerException {
+		checkArgumentNotNull("pipeName", pipeName);
+		this.pipeNames = new String[] { pipeName };
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setPipeNames(String... pipeNames) throws NullPointerException, IllegalArgumentException {
+		checkArgumentNotNull("pipeNames", pipeNames);
+		checkArgument("pipeNames", pipeNames.length > 0, "must not be empty");
+		this.pipeNames = pipeNames;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setRunAsArgs(String... runAsArgs) {
 		this.runAsArgs = runAsArgs;
 		return this;
 	}
-
-    public DefaultOfficeManagerConfiguration setTemplateProfileDir(File templateProfileDir) throws IllegalArgumentException {
-        if (templateProfileDir != null) {
-            checkArgument("templateProfileDir", templateProfileDir.isDirectory(), "must exist and be a directory");
-        }
-        this.templateProfileDir = templateProfileDir;
-        return this;
-    }
-
-    /**
-     * Sets the directory where temporary office profiles will be created.
-     * <p>
-     * Defaults to the system temporary directory as specified by the <code>java.io.tmpdir</code> system property.
-     * 
-     * @param workDir
-     * @return the DefaultOfficeManagerConfiguration
-     */
-    public DefaultOfficeManagerConfiguration setWorkDir(File workDir) {
-        checkArgumentNotNull("workDir", workDir);
-        this.workDir = workDir;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setTaskQueueTimeout(long taskQueueTimeout) {
-        this.taskQueueTimeout = taskQueueTimeout;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setTaskExecutionTimeout(long taskExecutionTimeout) {
-        this.taskExecutionTimeout = taskExecutionTimeout;
-        return this;
-    }
-
-    public DefaultOfficeManagerConfiguration setMaxTasksPerProcess(int maxTasksPerProcess) {
-        this.maxTasksPerProcess = maxTasksPerProcess;
-        return this;
-    }
-
-    /**
-     * Provide a specific {@link ProcessManager} implementation
-     * <p>
-     * The default is to use {@link SigarProcessManager} if sigar.jar is
-     * available in the classpath, otherwise {@link LinuxProcessManager}
-     * on Linux and {@link PureJavaProcessManager} on other platforms.
-     * 
-     * @param processManager
-     * @return
-     * @throws NullPointerException
-     */
-    public DefaultOfficeManagerConfiguration setProcessManager(ProcessManager processManager) throws NullPointerException {
-        checkArgumentNotNull("processManager", processManager);
-        this.processManager = processManager;
-        return this;
-    }
-
-    /**
-     * Retry timeout set in milliseconds. Used for retrying office process calls.
-     * If not set, it defaults to 2 minutes
-     * 
-     * @param retryTimeout in milliseconds
-     * @return
-     */
-    public DefaultOfficeManagerConfiguration setRetryTimeout(long retryTimeout) {
-        this.retryTimeout = retryTimeout;
-        return this;
-    }
-
-    public OfficeManager buildOfficeManager() throws IllegalStateException {
-        if (officeHome == null) {
-            throw new IllegalStateException("officeHome not set and could not be auto-detected");
-        } else if (!officeHome.isDirectory()) {
-            throw new IllegalStateException("officeHome doesn't exist or is not a directory: " + officeHome);
-        } else if (!OfficeUtils.getOfficeExecutable(officeHome).isFile()) {
-            throw new IllegalStateException("invalid officeHome: it doesn't contain soffice.bin: " + officeHome);
-        }
-        if (templateProfileDir != null && !isValidProfileDir(templateProfileDir)) {
-            throw new IllegalStateException("templateProfileDir doesn't appear to contain a user profile: " + templateProfileDir);
-        }
-        if (!workDir.isDirectory()) {
-            throw new IllegalStateException("workDir doesn't exist or is not a directory: " + workDir);
-        }
-
-        if (processManager == null) {
-            processManager = findBestProcessManager();
-        }
-        
-        int numInstances = connectionProtocol == OfficeConnectionProtocol.PIPE ? pipeNames.length : portNumbers.length;
-        UnoUrl[] unoUrls = new UnoUrl[numInstances];
-        for (int i = 0; i < numInstances; i++) {
-            unoUrls[i] = (connectionProtocol == OfficeConnectionProtocol.PIPE) ? UnoUrl.pipe(pipeNames[i]) : UnoUrl.socket(portNumbers[i]);
-        }
-        return new ProcessPoolOfficeManager(officeHome, unoUrls, runAsArgs, templateProfileDir, workDir, retryTimeout, taskQueueTimeout, taskExecutionTimeout, maxTasksPerProcess, processManager);
-    }
-
-    private ProcessManager findBestProcessManager() {
-        if (isSigarAvailable()) {
-            return new SigarProcessManager();
-        } else if (PlatformUtils.isLinux()) {
-        	LinuxProcessManager processManager = new LinuxProcessManager();
-        	if (runAsArgs != null) {
-        		processManager.setRunAsArgs(runAsArgs);
-        	}
-        	return processManager;
-        } else {
-            // NOTE: UnixProcessManager can't be trusted to work on Solaris
-            // because of the 80-char limit on ps output there  
-            return new PureJavaProcessManager();
-        }
-    }
-
-    private boolean isSigarAvailable() {
-        try {
-            Class.forName("org.hyperic.sigar.Sigar", false, getClass().getClassLoader());
-            return true;
-        } catch (ClassNotFoundException classNotFoundException) {
-            return false;
-        }
-    }
-
-    private void checkArgumentNotNull(String argName, Object argValue) throws NullPointerException {
-        if (argValue == null) {
-            throw new NullPointerException(argName + " must not be null");
-        }
-    }
-
-    private void checkArgument(String argName, boolean condition, String message) throws IllegalArgumentException {
-        if (!condition) {
-            throw new IllegalArgumentException(argName + " " + message);
-        }
-    }
-
-    private boolean isValidProfileDir(File profileDir) {
-        return new File(profileDir, "user").isDirectory();
-    }
-
+	
+	public DefaultOfficeManagerConfiguration setTemplateProfileDir(File templateProfileDir) throws IllegalArgumentException {
+		if (templateProfileDir != null) {
+			checkArgument("templateProfileDir", templateProfileDir.isDirectory(), "must exist and be a directory");
+		}
+		this.templateProfileDir = templateProfileDir;
+		return this;
+	}
+	
+	/**
+	 * Sets the directory where temporary office profiles will be created.
+	 * <p>
+	 * Defaults to the system temporary directory as specified by the <code>java.io.tmpdir</code> system property.
+	 * 
+	 * @param workDir
+	 * @return the DefaultOfficeManagerConfiguration
+	 */
+	public DefaultOfficeManagerConfiguration setWorkDir(File workDir) {
+		checkArgumentNotNull("workDir", workDir);
+		this.workDir = workDir;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setTaskQueueTimeout(long taskQueueTimeout) {
+		this.taskQueueTimeout = taskQueueTimeout;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setTaskExecutionTimeout(long taskExecutionTimeout) {
+		this.taskExecutionTimeout = taskExecutionTimeout;
+		return this;
+	}
+	
+	public DefaultOfficeManagerConfiguration setMaxTasksPerProcess(int maxTasksPerProcess) {
+		this.maxTasksPerProcess = maxTasksPerProcess;
+		return this;
+	}
+	
+	/**
+	 * Provide a specific {@link ProcessManager} implementation
+	 * <p>
+	 * The default is to use {@link SigarProcessManager} if sigar.jar is
+	 * available in the classpath, otherwise {@link LinuxProcessManager}
+	 * on Linux and {@link PureJavaProcessManager} on other platforms.
+	 * 
+	 * @param processManager
+	 * @return
+	 * @throws NullPointerException
+	 */
+	public DefaultOfficeManagerConfiguration setProcessManager(ProcessManager processManager) throws NullPointerException {
+		checkArgumentNotNull("processManager", processManager);
+		this.processManager = processManager;
+		return this;
+	}
+	
+	/**
+	 * Retry timeout set in milliseconds. Used for retrying office process calls.
+	 * If not set, it defaults to 2 minutes
+	 * 
+	 * @param retryTimeout in milliseconds
+	 * @return
+	 */
+	public DefaultOfficeManagerConfiguration setRetryTimeout(long retryTimeout) {
+		this.retryTimeout = retryTimeout;
+		return this;
+	}
+	
+	public OfficeManager buildOfficeManager() throws IllegalStateException {
+		if (officeHome == null) {
+			throw new IllegalStateException("officeHome not set and could not be auto-detected");
+		}
+		else if (!officeHome.isDirectory()) {
+			throw new IllegalStateException("officeHome doesn't exist or is not a directory: " + officeHome);
+		}
+		else if (!OfficeUtils.getOfficeExecutable(officeHome).isFile()) {
+			throw new IllegalStateException("invalid officeHome: it doesn't contain soffice.bin: " + officeHome);
+		}
+		if (templateProfileDir != null && !isValidProfileDir(templateProfileDir)) {
+			throw new IllegalStateException("templateProfileDir doesn't appear to contain a user profile: " + templateProfileDir);
+		}
+		if (!workDir.isDirectory()) {
+			throw new IllegalStateException("workDir doesn't exist or is not a directory: " + workDir);
+		}
+		
+		if (processManager == null) {
+			processManager = findBestProcessManager();
+		}
+		
+		int numInstances = connectionProtocol == OfficeConnectionProtocol.PIPE ? pipeNames.length : portNumbers.length;
+		UnoUrl[] unoUrls = new UnoUrl[numInstances];
+		for (int i = 0; i < numInstances; i++) {
+			unoUrls[i] = (connectionProtocol == OfficeConnectionProtocol.PIPE) ? UnoUrl.pipe(pipeNames[i]) : UnoUrl.socket(portNumbers[i]);
+		}
+		return new ProcessPoolOfficeManager(officeHome, unoUrls, runAsArgs, templateProfileDir, workDir, retryTimeout, taskQueueTimeout, taskExecutionTimeout, maxTasksPerProcess, processManager);
+	}
+	
+	private ProcessManager findBestProcessManager() {
+		if (isSigarAvailable()) {
+			return new SigarProcessManager();
+		}
+		else if (PlatformUtils.isLinux()) {
+			LinuxProcessManager processManager = new LinuxProcessManager();
+			if (runAsArgs != null) {
+				processManager.setRunAsArgs(runAsArgs);
+			}
+			return processManager;
+		}
+		else {
+			// NOTE: UnixProcessManager can't be trusted to work on Solaris
+			// because of the 80-char limit on ps output there
+			return new PureJavaProcessManager();
+		}
+	}
+	
+	private boolean isSigarAvailable() {
+		try {
+			Class.forName("org.hyperic.sigar.Sigar", false, getClass().getClassLoader());
+			return true;
+		}
+		catch (ClassNotFoundException classNotFoundException) {
+			return false;
+		}
+	}
+	
+	private void checkArgumentNotNull(String argName, Object argValue) throws NullPointerException {
+		if (argValue == null) {
+			throw new NullPointerException(argName + " must not be null");
+		}
+	}
+	
+	private void checkArgument(String argName, boolean condition, String message) throws IllegalArgumentException {
+		if (!condition) {
+			throw new IllegalArgumentException(argName + " " + message);
+		}
+	}
+	
+	private boolean isValidProfileDir(File profileDir) {
+		return new File(profileDir, "user").isDirectory();
+	}
+	
 }
Index: tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/UnoUrl.java
===================================================================
--- tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/UnoUrl.java	(revision 2405)
+++ tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/UnoUrl.java	(revision 2406)
@@ -19,6 +19,7 @@
  * Named pipes are marginally faster and do not take up a TCP port, but they
  * require native libraries, which means setting <em>java.library.path</em>
  * when starting Java. E.g. on Linux
+ * 
  * <pre>
  * java -Djava.library.path=/opt/openoffice.org/ure/lib ...
  * </pre>
@@ -27,36 +28,37 @@
  * in the OpenOffice.org Developer's Guide for more details.
  */
 class UnoUrl {
-
-    private final String acceptString;
-    private final String connectString;
-
-    private UnoUrl(String acceptString, String connectString) {
-        this.acceptString = acceptString;
-        this.connectString = connectString;
-    }
-
-    public static UnoUrl socket(int port) {
-        String socketString = "socket,host=127.0.0.1,port=" + port;
-        return new UnoUrl(socketString, socketString + ",tcpNoDelay=1");
-    }
-
-    public static UnoUrl pipe(String pipeName) {
-        String pipeString = "pipe,name=" + pipeName;
-        return new UnoUrl(pipeString, pipeString);
-    }
-
-    public String getAcceptString() {
-        return acceptString;
-    }
-
-    public String getConnectString() {
-        return connectString;
-    }
-
-    @Override
-    public String toString() {
-        return connectString;
-    }
-
+	
+	private final String acceptString;
+	
+	private final String connectString;
+	
+	private UnoUrl(String acceptString, String connectString) {
+		this.acceptString = acceptString;
+		this.connectString = connectString;
+	}
+	
+	public static UnoUrl socket(int port) {
+		String socketString = "socket,host=127.0.0.1,port=" + port;
+		return new UnoUrl(socketString, socketString + ",tcpNoDelay=1");
+	}
+	
+	public static UnoUrl pipe(String pipeName) {
+		String pipeString = "pipe,name=" + pipeName;
+		return new UnoUrl(pipeString, pipeString);
+	}
+	
+	public String getAcceptString() {
+		return acceptString;
+	}
+	
+	public String getConnectString() {
+		return connectString;
+	}
+	
+	@Override
+	public String toString() {
+		return connectString;
+	}
+	
 }
Index: tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/ExternalOfficeManager.java
===================================================================
--- tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/ExternalOfficeManager.java	(revision 2405)
+++ tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/ExternalOfficeManager.java	(revision 2406)
@@ -31,10 +31,11 @@
  * operations.
  */
 class ExternalOfficeManager implements OfficeManager {
-
+	
 	private final OfficeConnection connection;
+	
 	private final boolean connectOnStart;
-
+	
 	/**
 	 * @param unoUrl
 	 * @param connectOnStart
@@ -45,7 +46,7 @@
 		connection = new OfficeConnection(unoUrl);
 		this.connectOnStart = connectOnStart;
 	}
-
+	
 	public void start() throws OfficeException {
 		if (connectOnStart) {
 			synchronized (connection) {
@@ -53,7 +54,7 @@
 			}
 		}
 	}
-
+	
 	public void stop() {
 		synchronized (connection) {
 			if (connection.isConnected()) {
@@ -61,7 +62,7 @@
 			}
 		}
 	}
-
+	
 	public void execute(OfficeTask task) throws OfficeException {
 		synchronized (connection) {
 			if (!connection.isConnected()) {
@@ -70,17 +71,18 @@
 			task.execute(connection);
 		}
 	}
-
+	
 	private void connect() {
 		try {
 			connection.connect();
-		} catch (ConnectException connectException) {
+		}
+		catch (ConnectException connectException) {
 			throw new OfficeException("could not connect to external office process", connectException);
 		}
 	}
-
+	
 	public boolean isRunning() {
 		return connection.isConnected();
 	}
-
+	
 }
Index: tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/PooledOfficeManager.java
===================================================================
--- tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/PooledOfficeManager.java	(revision 2405)
+++ tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/PooledOfficeManager.java	(revision 2406)
@@ -20,91 +20,103 @@
 import java.util.logging.Logger;
 
 class PooledOfficeManager implements OfficeManager {
-
-    private final PooledOfficeManagerSettings settings;
-    private final ManagedOfficeProcess managedOfficeProcess;
-    private final SuspendableThreadPoolExecutor taskExecutor;
-
-    private volatile boolean stopping = false;
-    private int taskCount;
-    private Future<?> currentTask;
-
-    private final Logger logger = Logger.getLogger(getClass().getName());
-
-    private OfficeConnectionEventListener connectionEventListener = new OfficeConnectionEventListener() {
-        public void connected(OfficeConnectionEvent event) {
-            taskCount = 0;
-            taskExecutor.setAvailable(true);
-        }
-        public void disconnected(OfficeConnectionEvent event) {
-            taskExecutor.setAvailable(false);
-            if (stopping) {
-                // expected
-                stopping = false;
-            } else {
-                if (DefaultOfficeManagerConfiguration.DEBUG) logger.warning("connection lost unexpectedly; attempting restart");
-                if (currentTask != null) {
-                    currentTask.cancel(true);
-                }
-                managedOfficeProcess.restartDueToLostConnection();
-            }
-        }
-    };
-
-    public PooledOfficeManager(UnoUrl unoUrl) {
-        this(new PooledOfficeManagerSettings(unoUrl));
-    }
-
-    public PooledOfficeManager(PooledOfficeManagerSettings settings) {
-        this.settings = settings;
-        managedOfficeProcess = new ManagedOfficeProcess(settings);
-        managedOfficeProcess.getConnection().addConnectionEventListener(connectionEventListener);
-        taskExecutor = new SuspendableThreadPoolExecutor(new NamedThreadFactory("OfficeTaskThread"));
-    }
-
-    public void execute(final OfficeTask task) throws OfficeException {
-        Future<?> futureTask = taskExecutor.submit(new Runnable() {
-            public void run() {
-                if (settings.getMaxTasksPerProcess() > 0 && ++taskCount == settings.getMaxTasksPerProcess() + 1) {
-                    if (DefaultOfficeManagerConfiguration.DEBUG) logger.info(String.format("reached limit of %d maxTasksPerProcess: restarting", settings.getMaxTasksPerProcess()));
-                    taskExecutor.setAvailable(false);
-                    stopping = true;
-                    managedOfficeProcess.restartAndWait();
-                    //FIXME taskCount will be 0 rather than 1 at this point
-                }
-                task.execute(managedOfficeProcess.getConnection());
-             }
-         });
-         currentTask = futureTask;
-         try {
-             futureTask.get(settings.getTaskExecutionTimeout(), TimeUnit.MILLISECONDS);
-         } catch (TimeoutException timeoutException) {
-             managedOfficeProcess.restartDueToTaskTimeout();
-             throw new OfficeException("task did not complete within timeout", timeoutException);
-         } catch (ExecutionException executionException) {
-             if (executionException.getCause() instanceof OfficeException) {
-                 throw (OfficeException) executionException.getCause();
-             } else {
-                 throw new OfficeException("task failed", executionException.getCause());
-             }
-         } catch (Exception exception) {
-             throw new OfficeException("task failed", exception);
-         }
-    }
-
-    public void start() throws OfficeException {
-        managedOfficeProcess.startAndWait();
-    }
-
-    public void stop() throws OfficeException {
-        taskExecutor.setAvailable(false);
-        stopping = true;
-        taskExecutor.shutdownNow();
-        managedOfficeProcess.stopAndWait();
-    }
-
+	
+	private final PooledOfficeManagerSettings settings;
+	
+	private final ManagedOfficeProcess managedOfficeProcess;
+	
+	private final SuspendableThreadPoolExecutor taskExecutor;
+	
+	private volatile boolean stopping = false;
+	
+	private int taskCount;
+	
+	private Future<?> currentTask;
+	
+	private final Logger logger = Logger.getLogger(getClass().getName());
+	
+	private OfficeConnectionEventListener connectionEventListener = new OfficeConnectionEventListener() {
+		
+		public void connected(OfficeConnectionEvent event) {
+			taskCount = 0;
+			taskExecutor.setAvailable(true);
+		}
+		
+		public void disconnected(OfficeConnectionEvent event) {
+			taskExecutor.setAvailable(false);
+			if (stopping) {
+				// expected
+				stopping = false;
+			}
+			else {
+				if (DefaultOfficeManagerConfiguration.DEBUG) logger.warning("connection lost unexpectedly; attempting restart");
+				if (currentTask != null) {
+					currentTask.cancel(true);
+				}
+				managedOfficeProcess.restartDueToLostConnection();
+			}
+		}
+	};
+	
+	public PooledOfficeManager(UnoUrl unoUrl) {
+		this(new PooledOfficeManagerSettings(unoUrl));
+	}
+	
+	public PooledOfficeManager(PooledOfficeManagerSettings settings) {
+		this.settings = settings;
+		managedOfficeProcess = new ManagedOfficeProcess(settings);
+		managedOfficeProcess.getConnection().addConnectionEventListener(connectionEventListener);
+		taskExecutor = new SuspendableThreadPoolExecutor(new NamedThreadFactory("OfficeTaskThread"));
+	}
+	
+	public void execute(final OfficeTask task) throws OfficeException {
+		Future<?> futureTask = taskExecutor.submit(new Runnable() {
+			
+			public void run() {
+				if (settings.getMaxTasksPerProcess() > 0 && ++taskCount == settings.getMaxTasksPerProcess() + 1) {
+					if (DefaultOfficeManagerConfiguration.DEBUG) logger.info(String.format("reached limit of %d maxTasksPerProcess: restarting", settings.getMaxTasksPerProcess()));
+					taskExecutor.setAvailable(false);
+					stopping = true;
+					managedOfficeProcess.restartAndWait();
+					// FIXME taskCount will be 0 rather than 1 at this point
+				}
+				task.execute(managedOfficeProcess.getConnection());
+			}
+		});
+		currentTask = futureTask;
+		try {
+			futureTask.get(settings.getTaskExecutionTimeout(), TimeUnit.MILLISECONDS);
+		}
+		catch (TimeoutException timeoutException) {
+			managedOfficeProcess.restartDueToTaskTimeout();
+			throw new OfficeException("task did not complete within timeout", timeoutException);
+		}
+		catch (ExecutionException executionException) {
+			if (executionException.getCause() instanceof OfficeException) {
+				throw (OfficeException) executionException.getCause();
+			}
+			else {
+				throw new OfficeException("task failed", executionException.getCause());
+			}
+		}
+		catch (Exception exception) {
+			throw new OfficeException("task failed", exception);
+		}
+	}
+	
+	public void start() throws OfficeException {
+		managedOfficeProcess.startAndWait();
+	}
+	
+	public void stop() throws OfficeException {
+		taskExecutor.setAvailable(false);
+		stopping = true;
+		taskExecutor.shutdownNow();
+		managedOfficeProcess.stopAndWait();
+	}
+	
 	public boolean isRunning() {
 		return managedOfficeProcess.isConnected();
 	}
-
+	
 }
Index: tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/Retryable.java
===================================================================
--- tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/Retryable.java	(revision 2405)
+++ tmp/org.txm.jodconverter.core/src/main/java/org/artofsolving/jodconverter/office/Retryable.java	(revision 2406)
@@ -13,43 +13,46 @@
 package org.artofsolving.jodconverter.office;
 
 abstract class Retryable {
-
-    /**
-     * @throws TemporaryException for an error condition that can be temporary - i.e. retrying later could be successful
-     * @throws Exception for all other error conditions
-     */
-    protected abstract void attempt() throws TemporaryException, Exception;
-
-    public void execute(long interval, long timeout) throws RetryTimeoutException, Exception {
-        execute(0L, interval, timeout);
-    }
-
-    public void execute(long delay, long interval, long timeout) throws RetryTimeoutException, Exception {
-        long start = System.currentTimeMillis();
-        if (delay > 0L) {
-            sleep(delay);
-        }
-        while (true) {
-            try {
-                attempt();
-                return;
-            } catch (TemporaryException temporaryException) {
-                if (System.currentTimeMillis() - start < timeout) {
-                    sleep(interval);
-                    // continue
-                } else {
-                    throw new RetryTimeoutException(temporaryException.getCause());
-                }
-            }
-        }
-    }
-
-    private void sleep(long millis) {
-        try {
-            Thread.sleep(millis);
-        } catch (InterruptedException interruptedException) {
-            // continue
-        }
-    }
-
+	
+	/**
+	 * @throws TemporaryException for an error condition that can be temporary - i.e. retrying later could be successful
+	 * @throws Exception for all other error conditions
+	 */
+	protected abstract void attempt() throws TemporaryException, Exception;
+	
+	public void execute(long interval, long timeout) throws RetryTimeoutException, Exception {
+		execute(0L, interval, timeout);
+	}
+	
+	public void execute(long delay, long interval, long timeout) throws RetryTimeoutException, Exception {
+		long start = System.currentTimeMillis();
+		if (delay > 0L) {
+			sleep(delay);
+		}
+		while (true) {
+			try {
+				attempt();
+				return;
+			}
+			catch (TemporaryException temporaryException) {
+				if (System.currentTimeMillis() - start < timeout) {
+					sleep(interval);
+					// continue
+				}
+				else {
+					throw new RetryTimeoutException(temporaryException.getCause());
+				}
+			}
+		}
+	}
+	
+	private void sleep(long millis) {
+		try {
+			Thread.sleep(millis);
+		}
+		catch (InterruptedException interruptedException) {
+			// continue
+		}
+	}
+	
 }
